

#ifndef STEPMOTOR_HEADER
#define STEPMOTOR_HEADER


//#define USE_ENDPOSITION_SWITCH_INT0
#define STEPMOTOR_USED


typedef struct
	{
	float fSM_Soll_FRQ;	
	float fSM_Ist_Frq;		//Wird incrementiert bis == gsStMPar.fSM_Soll_FRQ fr Rampe	
	uint8_t u8SM_RampenSteigung;
	uint8_t u8SM_Mode;	//Full=1 Half  = 2
	uint32_t u32MovedSteps;//compare with MovedSteps //Wieviel hat sich der Motor gedreht..		
	uint32_t u32SM_ToRunCnt;	//PULSE die der Motor laufen soll	
	uint16_t u16SM_StepsRotationType; //=PREFDEF_STEPS_PER_ROTATION
	uint16_t u16StepsPerRotation; //u8SM_Mode * u16SM_StepsRotationType=PREFDEF_STEPS_PER_ROTATION= 
	uint8_t u8Stop_PWM_Rate; //u0 ..255
}STEPMPARTYPE;	//gsStMPar.ucStepMConditionFlag


//REGISTER
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_STOP	0x00	
#define TCCR0_CLK_0		0x01	//62500 PWM
#define TCCR0_CLK_8		0x02	//7812 Hz PWM
#define TCCR0_CLK_64		0x03	//976,56Hz PWM
#define TCCR0_CLK_256	0x04	//244,14Hz PWM
#define TCCR0_CLK_1024	0x05	//~61,035 PWM
#define TCCR0_EXT_CLK_FALL_T0	0x06	
#define TCCR0_EXT_CLK_RISE_T0	0x07
#define TCCR0_CLK_STOP_MASK	0xF8	



#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00


//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CLOCKSEL_MSK		0xF8 // zum Stoppen der CLK
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64	0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256	0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits




#define PULS_PER_SECOND_T1	15625.0 //TCCR2_CLK_1024
#define SM_AFTERSTOPDELAY_TICKS	2	//~16ms 1=TIMER2_INTPERIODE

//STEPMOTOR HARDWARE
#define SM_PORT_OUT	PORTA	
#define SM_PORT_IN	PINA	
#define SM_PORT	PORTA	
#define SM_DIRREG	DDRA

#define SM_ALLCTRL_MSK	0x3F
#define SM_INPX_MSK		0x0F
#define SM_ENABLE_MSK	0x30

#define SM_INP1	0x01
#define SM_INP2	0x02
#define SM_INP3	0x04
#define SM_INP4 	0x08
#define SM_ENA_A 	0x10
#define SM_ENA_B 	0x20
#define SM_ISENS_A	0x40
#define SM_ISENS_B	0x80

 
#define SM_INIT_DIRREG()   (SM_DIRREG |= SM_ALLCTRL_MSK) // OUT richtig Stellen

// SPEZIFISCHE DEFINITIONEN; JE NACH HARDWARE
//BEI 16 MHz Quarz = F_CPU / Teiler
// QUARZ/DIVIDE = FREQUENZ
#define TIMER_DIVIDE_FRQ_1		((float)F_CPU)	// 16000000UL
#define TIMER_DIVIDE_FRQ_8		((float)F_CPU / 8) //2000000UL		
#define TIMER_DIVIDE_FRQ_64	((float)F_CPU / 64) //250000UL
#define TIMER_DIVIDE_FRQ_256	((float)F_CPU / 256) //62500U
#define TIMER_DIVIDE_FRQ_1024	((float)F_CPU / 1024) //15625U

#define MAXIMAL_FRQ	800
#define  MINIMAL_FRQ	0.2

#define FULLSTEPMODEPARSMAX 4	
#define HALFSTEPMODEPARSMAX 8	
//#define QUARTERSTEPMODEPARSMAX 16
//#define EIGHTHSTEPMODEPARSMAX 32
#define MODE_FULLSTEP	1	//Multiplikator 1X. gsStMPar.ucStepMConditionFlag |=  MODE_FULLSTEP
#define MODE_HALFSTEP 	2	//Multiplikator 2X. Set_StepMotor_Mode(gsStMPar.ucStepMConditionFlag & STEPM_STEPMODE_)
#define FULLROT_DEGREE_360			360.0	//muss float sein
#define Motor_START_LAST_BITPATTERN_ON_TIME 15 //~20ms sec ms Zeit, damit der Motor unter vor der Bewegung unter Strom gesetzt wird.
//STEP FRQ
#define FRQ_OFF	0
#define FRQ_ON		1
//DIRECTION
#define SM_DIR_RECHTS	0
#define SM_DIR_LINKS		1

#define MOTORSTOP_PWM	200 // PWM RATE fuer den Motor bei Stop 8KHZ


#define PREFDEF_STEPS_PER_ROTATION	200 //DEFAULT, 200 Normal, 400=Fein=0.9Degree, grob=30=~12.857Degree
#define PREDEF_STEPFREQUENZ 			100.0	//Hz
#define PREDEF_RAMPENSSTARTFRQ		10.0	//Die Frq ab der berhaubt erst eine Rampe gefahren wird..
#define PREDEF_RAMP_RISE 				0	//Anstieg der RampenFrequenz
#define PREDEF_STEPRCLOCKS  			1	//STEPS
#define PREDDEF_STEPMODE				MODE_HALFSTEP
#define PREDEF_STOP_PWM_RATE			180 // 0.255 WPM bei 62500kHZ 


//Es wird unterschieden nach CTRL und Condition Flags
//in STRUCT STEPMPARTYPE;
//Flags
#define STEPM_ENABLE_FLAG			0x01	// 0 = OFF
#define STEPM_PULSE_MODE_FLAG		0x02	// 0 = OFF
#define STEPM_RAMPE_FLAG			0x04	// MIT_RAMPE, ?
#define STEPM_START_RAMPE_FLAG	0x08	// 0 = Selected Counts, 1 = Countinous
//------
#define STEPM_STOP_ACTIVE_FLAG	0x10	//STOP, BUT ENABLED, (STROM ON!!) Absicht!!, STEMotor StoptMode ..mit ICTRL, SPTER PWM, oder Automatische Disable nach Timeout.
#define STEPM_TIMEOUT_ENABLE_FLAG	0x20	//After Stop Auto Disable after TIMEOUT
#define STEPM_DIRECTION_FLAG		0x40	// 0 = rechts ?? unbestimmt je nach verdrahtung
#define STEPM_RUN_FLAG				0x80	//Ohne RemainTime Zurcksetzung Run=Continue condtition
//	gsStMPar.ucStepMConditionFlag;	//ISTZUSTAND


#define POSITION_Index_Valid_FLAG		0x01
#define POSITION_LOW_DETECT				0x02
#define POSITION_HIGH_DETECT				0x04
//------
#define POSITION_STOP_ON_TARGET_MODE_FLAG	0x10	
#define POSITION_STOP_ON_TARGET_OK			0x20	
#define POSITION_STOP_ON_DISTANCE_MODE_FLAG	0x40	
#define POSITION_STOP_ON_DISTANCE_OK	0x80	

//gu8SM_PostionFlag
extern uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings

extern STEPMPARTYPE gsStMPar;
extern uint8_t gu8StepMConditionFlag;	//ISTZUSTAND wir Mode
extern uint8_t gu8SM_PostionFlag;

extern void Timer0_PWM(unsigned char ucPwmRange);
extern void Set_StepMotor_Mode(uint8_t ucVal); 
extern void SetMotorDirection(uint8_t ucVal);
extern void StepMotorOn(void);
extern void StepMotorStop(void);
extern void StepMotorOff(void);
extern void Set_SM_FRQ(float fVal);
extern void StepFRQ_OnOff(uint8_t uOnOff);
extern void SM_Run_Puls_DIR(uint32_t uiPuls, uint8_t ucDir);
extern void SM_InitStructVals(void);


//-----------------------------------------------------------
#endif //STEPMOTOR_HEADER